<template>
    <div>
        <v-container class="mb-6">
            <h2>Network setup</h2>
            <v-row>
                <v-col>
                    <AlphabetChips
                            v-model="network.alphabet"
                            :load-items="network.alphabet"
                            :disabled="network.created" />
                </v-col>
            </v-row>

            <!-- TODO add min and max values -->
            <v-row>
                <v-col>
                    <v-text-field label="Hidden layers number"
                                  type="number"
                                  v-model="network.hiddenLayersNumber"
                                  :disabled="network.created" />
                </v-col>
                <v-col>
                    <v-text-field label="Neurons per layer"
                                  type="number"
                                  v-model="network.neuronsPerLayer"
                                  :disabled="network.created" />
                </v-col>
                <v-col>
                    <v-text-field label="Picture width"
                                  type="number"
                                  suffix="px"
                                  v-model="network.picWidth"
                                  :disabled="network.created" />
                </v-col>
                <v-col>
                    <v-text-field label="Picture height"
                                  type="number"
                                  suffix="px"
                                  v-model="network.picHeight"
                                  :disabled="network.created" />
                </v-col>
            </v-row>
            <v-btn color="primary"
                   :disabled="network.created"
                   @click="createNetwork">Create</v-btn>
        </v-container>

        <div v-if="network.created">
            <v-container>
                <h2>Assets</h2>

                <v-combobox
                        v-model="selectedCharacter"
                        :items="network.alphabet"
                        label="Select character"
                ></v-combobox>
            </v-container>

            <v-container v-if="selectedCharacter" class="nma-2">
                <v-file-input v-model="files"
                              multiple
                              label="Select pictures" />
                <v-btn color="primary" @click="startUpload">Upload</v-btn>

                <AssetsManager :api="api.assets">
                    <template v-slot:default="props">
                        <div class="nma-2 mt-2">
                            <div  v-for="item in props.items"
                                  :key="item.id" class="d-inline-block mx-auto pa-2">
                                <!-- TODO try to move the logic into a component method (which can be then passed to props) -->
                                <v-card class="pa-2 pr-9"
                                        @click="props.select(item, !props.isSelected(item))">
                                    <v-img :src="getPicUrl(item)" :width="picSize.width" :height="picSize.height" />
                                    <v-checkbox
                                            :input-value="props.isSelected(item)"
                                            class="corner-checkbox" />
                                </v-card>
                            </div>
                        </div>
                    </template>
                </AssetsManager>
            </v-container>
        </div>
    </div>
</template>

<script>
    import Api from "../../api/Api";
    import AssetsManager from "../common/AssetsManager";
    import AlphabetChips from "./AlphabetChips";

    export default {

        name: "CharRecManager",

        components: {AlphabetChips, AssetsManager},

        data: () => ({
            api: Api.characterRecognizing,
            files: null,
            // TODO receive these from backend
            picSize: { width: 30, height: 30 },
            network: {
                alphabet: [],
                created: null,
                taught: null,
                hiddenLayersNumber: null,
                neuronsPerLayer: null,
                picWidth: null,
                picHeight: null
            },
            selectedCharacter: null,
            selectedAssets: []
        }),


        methods: {
            createNetwork() {
                this.api.network.create(this.network).then(() => this.network.created = true);
            },
            startUpload() {
                this.api.assets.upload(this.files, { character: this.selectedCharacter });
            },
            getPicUrl(picture) {
                return Api.characterRecognizing.assets.getUrl(picture.id);
            }
        },


        mounted() {

            this.api.network.getFlags().then(response => {
                this.network.created = response.charRecNetworkCreated;
                this.network.taught = response.charRecNetworkTaught;
            });

            this.api.network.getAlphabet().then(response => {
                this.network.alphabet = response;
            });

        }
    }
</script>

<style scoped>
    .corner-checkbox {
        position: absolute;
        top: -18px;
        right: -7px;
    }
</style>